# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include "mppath.h"

int main (int argc, char ** argv) 
{
	MP mp ;
	MP_options * opt = mp_options () ;
	opt -> command_line = NULL;
	opt -> noninteractive = 1 ; 
	mp = mp_initialize ( opt ) ;
	if ( ! mp ) exit ( EXIT_FAILURE ) ;
	mp_knot *p, *first, *q; 
	p = mp_append_knot(mp,NULL,0,0); 
	if ( ! p ) exit ( EXIT_FAILURE ) ;
	first = p;
	/* (0,0)..(2,20) */
	q = mp_append_knot(mp,p,2,20);  
	if ( ! q ) exit ( EXIT_FAILURE ) ;
	p = mp_append_knot(mp,q,10,5);
	if ( ! p ) exit ( EXIT_FAILURE ) ;
        /* (2,20){curl1}..{curl1}(10, 5) */
	if (!mp_set_knotpair_curls(mp, q,p, 1.0, 1.0)) exit ( EXIT_FAILURE ) ; 
	q = mp_append_knot(mp,p,3,10);
	if ( ! q ) exit ( EXIT_FAILURE ) ;
        /* (10, 5)..controls (2,2) and (9,4.5)..(3,10) */
	if (!mp_set_knotpair_controls(mp, p,q, 2.0, 2.0, 9.0, 4.5)) exit ( EXIT_FAILURE ) ; 
	p = mp_append_knot(mp,q,1,14);
	if ( ! p ) exit ( EXIT_FAILURE ) ;
        /* (3,10)..tension 3 and atleast 4 .. (1,14) */
	if (!mp_set_knotpair_tensions(mp,q,p, 3.0, -4.0)) exit ( EXIT_FAILURE ) ;
	q = mp_append_knot(mp,p,5,-4);
	if ( ! q ) exit ( EXIT_FAILURE ) ;
        /* (1, 14){2,0} .. {0,1}(5,-4) */
	if (!mp_set_knotpair_directions(mp, p,q, 2.0, 0.0, 0.0, 1.0)) exit ( EXIT_FAILURE ) ;
	
	mp_final_knotpair(mp, q, first);

	mp_dump_path(mp, first);
	if (mp_solve_path(mp, first)) {
	    mp_dump_path(mp, first);
	}
	mp_free_path(mp, first);

	p = mp_append_knot(mp,NULL,0,0); 
	first = p;
	q = mp_append_knot(mp,p,10,10); 
	p = mp_append_knot(mp,q,10,-5); 
	mp_cycle_knotpair(mp, p, first);
	mp_dump_path(mp, first);
	if (mp_solve_path(mp, first)) {
	    mp_dump_path(mp, first);
	}
	mp_free_path(mp, first);

	mp_finish ( mp ) ;
	return 0;
}
